function [P,P1,D] = diagsys(U,gamma)
%
%        [P,P1,D] = diagsys(U,gamma)
%
%               formato escritura
% P = [p11 p21 ... pN1 p12 p22 ... pN2 ... p1N p2N ... pNN]
%

[nnod,ndf]=size(U);

tol    = 1e-16;
g1     =  gamma-1;     
if 0
    rho    =  U(:,1);
    Ucell  =  U(:,2)./(rho);
    pres   =  (U(:,3)-0.5*U(:,1).*U(:,2))*g1;
else
    Up = cv2pv(U,gamma,1);
    rho = Up(:,1);
    Ucell = Up(:,2);
    pres = Up(:,3);
end
cc     =  sqrt(gamma*pres./rho);
uno    =  ones(nnod,1);
cero   =  zeros(nnod,1);


P1 = [ (cc.^2/g1+0.5*Ucell.*cc).*Ucell ...
        (2*cc.^2/g1-Ucell.^2).*cc ...
        Ucell.*cc.*(0.5*Ucell-cc/g1) ...
        -(cc.^2/g1+Ucell.*cc) ...
        2*Ucell.*cc ...
        cc.^2/g1-Ucell.*cc ...
        cc -2*cc cc ];
    
    P1 = ((g1/2 ./ cc.^3)*ones(1,9)).*P1;
    
    P1 = reshape(P1,nnod,ndf,ndf);
    
    P = [ uno Ucell-cc ...
            cc.^2/g1+0.5*Ucell.^2-Ucell.*cc ...
            uno Ucell  0.5*Ucell.^2 ...
        uno Ucell+cc ...
        cc.^2/g1+0.5*Ucell.^2+Ucell.*cc ];
    
    P = reshape(P,nnod,ndf,ndf);
    
    D(:,1) = Ucell-cc;
    D(:,2) = Ucell;
    D(:,3) = Ucell+cc;