%
%   Ejemplo SOD Test # 1 : Euler
%


xnod  = [];
icone = [];
Nx    = 201;
Lx    =  20;
psi   = (0:Nx-1)'/(Nx-1);
x     = -Lx/2+psi*Lx;

%-------- coordenadas (XNOD)
xnod  =  x;

%-------- conectividades (ICONE)
icone = [ (1:Nx-1)' (2:Nx)' ];

%-------- fijaciones (FIXA)
[numnp,ndm]=size(xnod);
[numel,nen]=size(icone);
ndf = 3;
nodes_lef  = 1;
nodes_rig  = Nx;

fixa= zeros(numnp,ndf);
%fixa(nodes_lef,[1,2,3])=ones(length(nodes_lef),3);
%fixa(nodes_rig,[1,2,3])=ones(length(nodes_rig),3);

%-------- Cargas/Desplazamientos nodales(FORC)
rho_L = 1;
rho_R = 1/8;
u_L   = 0;
u_R   = 0;
p_L   = 1e5;
p_R   = 1e4;

forc= zeros(numnp,ndf);
%forc(nodes_lef,1:3) =  ones(length(nodes_lef),1)*[rho_L,u_L,p_L];
%forc(nodes_rig,1:3) =  ones(length(nodes_rig),1)*[rho_R,u_R,p_R];

%-------- Propiedades del material
gamma   = 1.4  ;
Cou     = 1.0  ;
npg     =  2   ;

prop(1) =gamma ;
prop(2) =Cou   ;
prop(3) =npg   ;

upwind   =      1 ;
shocap   =      0 ;
lumped   =      1 ;
type_var = 0;  % conservative variables
%type_var = 1;  % characteristics variables NO SE USA

prop(4)  = upwind ;
prop(5)  = shocap ;
prop(6)  = lumped ;
prop(7)  = type_var;
 
matrix_type = 'full';  % arma el jacobiano lo mejor posible
%matrix_type = 'diag';  % solo la matriz de masa y lumped 
%------------------------------------------------------------
% upwind Tezduyar else diagonalizacion analitica
tau_TET = 1;
  
%------------------------------------------------------------
% debilito termino advectivo Galerkin o no
weak_form = 1;

if exist('matrix_type'),
   if matrix_type=='diag', prop(8) = 0; else prop(8) = 1; end 
end

prop(9) = tau_TET;    
prop(10) = weak_form;

ALE_flag = 0;

% no se usan pero deben estar 
strg = [];
teco = []; 

% Restricciones lineales ----> Condiciones periodicas
lin_con = [];

%-------- Solucion inicial (PHI)
U      =  ones(numnp,1)*[rho_L,u_L,p_L];
nn     =  find(xnod>0);
U(nn,1:3) = ones(length(nn),1)*[rho_R,u_R,p_R];

% conversion a conservativas
%-----------------------------------------------
bini = U;
for k=1:ndf
 nofree = find(fixa(:,k)~=0);
 bini(nofree,k) = forc(nofree,k);
end
