%
%   Test: discontinuidad de contacto 1D
%

p0   = 1e5;
rho0 = 1;
M0   = .001;

R = 287;
gamma = 1.4;

T0 = p0/(R*rho0);
U0 = M0*sqrt(gamma*R*T0);

xnod  = [];
icone = [];
Nx    = 401;
Lx    = 800;
psi   = (0:Nx-1)'/(Nx-1);
x     = psi*Lx;

%-------- coordenadas (XNOD)
xnod  =  x;

%-------- conectividades (ICONE)
icone = [ (1:Nx-1)' (2:Nx)' ];

%-------- fijaciones (FIXA)
[numnp,ndm]=size(xnod);
[numel,nen]=size(icone);
ndf = 3;
nodes_lef  = 1;
nodes_rig  = Nx;

fixa= zeros(numnp,ndf);
%% fixa(nodes_lef,[1 2]) = ones(length(nodes_lef),2);
%% fixa(nodes_rig,3) = ones(length(nodes_rig),1);

%-------- Cargas/Desplazamientos nodales(FORC)
forc= zeros(numnp,ndf);
%% forc(nodes_lef,1) = rho0*ones(length(nodes_lef),1);
%% forc(nodes_lef,2) = U0*ones(length(nodes_lef),1);
%% forc(nodes_rig,3) = p0/(gamma*M0^2)*ones(length(nodes_rig),1);

%-------- Propiedades del material
gamma   = 1.4  ;
Cou     = 1.0  ;
npg     =  2   ;

prop(1) =gamma ;
prop(2) =Cou   ;
prop(3) =npg   ;

upwind   =      1 ;
shocap   =      0 ;
lumped   =      1 ;
type_var = 0;  % conservative variables
%type_var = 1;  % characteristics variables NO SE USA

prop(4)  = upwind ;
prop(5)  = shocap ;
prop(6)  = lumped ;
prop(7)  = type_var;
 
matrix_type = 'full';  % arma el jacobiano lo mejor posible
%matrix_type = 'diag';  % solo la matriz de masa y lumped 
%------------------------------------------------------------
% upwind Tezduyar else diagonalizacion analitica
tau_TET = 1;
  
%------------------------------------------------------------
% debilito termino advectivo Galerkin o no
weak_form = 0;

if exist('matrix_type'),
   if matrix_type=='diag', prop(8) = 0; else prop(8) = 1; end 
end

ALE_flag = 0;

prop(9)  = tau_TET;    
prop(10) = weak_form;
prop(11) = ALE_flag;

% no se usan pero deben estar 
strg = [];
teco = []; 

% Restricciones lineales ----> Condiciones periodicas
lin_con = [];

%-------- Solucion inicial (PHI)
U = ones(numnp,1)*[rho0 U0 p0];
U(:,1) = rho0*(xnod <= Lx/2) + ...
    2*rho0*(xnod > Lx/2);

%% U = cv2pv(U,gamma,0);

% conversion a conservativas
%-----------------------------------------------
bini = U;
for k=1:ndf
 nofree = find(fixa(:,k)~=0);
 bini(nofree,k) = forc(nofree,k);
end

nodes_sampling = [1 (Nx-1)/2+1 Nx];

bc_time_flag = 0;
