function [Fa,Ax] = fluxa_1D(Uc,Up,gamma,Cp)
%
%  [Fa,Ax] = fluxa_1D(Uc,Up,gamma,Cp)
%

[N,ndof] = size(Uc);
g1 = gamma-1;

Fa = zeros(N,ndof,1);
Fa(:,1) = Uc(:,2);
Fa(:,2) = Uc(:,2).*Up(:,2)+Up(:,3);
H       = Uc(:,3)+Up(:,3);
Fa(:,3) = H.*Up(:,2); 

Ax_tmp  = Ajac_euler_1D(Uc,Up,gamma);
Ax      = rowprod(Ax_tmp,Cp,ndof,ndof,ndof);

