function iGamma = ipreco(Uc,Up,gamma,dt,h)
%
%  iGamma = ipreco(Uc,Up,gamma,dt,h)
%

[N,ndof] = size(Uc);
g1 = gamma-1;

delta = 1;
Meps  = 1e-6;
xi    = 1;

c = sqrt(gamma*Up(:,3)./Up(:,1));
beta = c.^2; % Por ahora solo se considera el caso inviscido
M = abs(Up(:,2))./c;

CFLc = c*dt./h;

Mr = min([ones(size(M)) max([sqrt(M.^2+xi./CFLc.^2) Meps*ones(size(M))],[],2)],[],2);

psi = g1./(beta.*Mr.^2);

XI    = (Uc(:,3)+Up(:,3))./(Uc(:,1).*beta.*Mr.^2)-delta;
kappa = Up(:,1)./(gamma*Up(:,3)).*(gamma*beta.*Mr.^2-g1*Up(:,2).^2+g1*beta*Mr.^2.*XI);

iGamma = zeros(N,ndof,ndof);
iGamma(:,1,1) = kappa;
iGamma(:,1,2) = g1/gamma*Up(:,1).*Up(:,2)./Up(:,3);
iGamma(:,1,3) = -g1/gamma*Up(:,1)./Up(:,3);
iGamma(:,2,1) = (kappa-1).*Up(:,2);
iGamma(:,2,2) = 1+g1/gamma*Up(:,1).*Up(:,2).^2./Up(:,3);
iGamma(:,2,3) = -g1/gamma*Up(:,1).*Up(:,2)./Up(:,3);
iGamma(:,3,1) = 1./psi+Up(:,2).^2.*(kappa/2-1);
iGamma(:,3,2) = Up(:,2).*(1+.5*g1/gamma*Up(:,1).*Up(:,2).^2./Up(:,3));
iGamma(:,3,3) = -.5*g1/gamma*Up(:,1).*Up(:,2).^2./Up(:,3);
