function iGammav = iprecov(U,gamma,dt,h)
%
%   iGammav = iprecov(U,gamma,dt,h)
%

[N,ndof] = size(U);
g1 = gamma-1;
R_gas = 287;

delta = 1;
Meps  = 1e-6;
xi    = 1;

c = sqrt(gamma*U(:,3)./U(:,1));
beta = c.^2; % Por ahora solo se considera el caso inviscido
M = abs(U(:,2))./c;

CFLc = c*dt./h;

%% Mr = min([ones(size(M)) max([M Meps*ones(size(M))],[],2)],[],2);
Mr = min([ones(size(M)) max([sqrt(M.^2+xi./CFLc.^2) Meps*ones(size(M))],[],2)],[],2);

iGammav = zeros(N,ndof,ndof);

iGammav(:,1,1) = beta.*Mr.^2;
iGammav(:,2,1) = -U(:,2)./U(:,1);
iGammav(:,2,2) = 1./U(:,1);
iGammav(:,3,1) = -U(:,3)./(R_gas*U(:,1).^2)+ ...
    g1./(gamma*R_gas*U(:,1)).*(U(:,2).^2/2+delta*beta.*Mr.^2);
iGammav(:,3,2) = -g1./(gamma*R_gas*U(:,1)).*U(:,2);
iGammav(:,3,3) = g1./(gamma*R_gas*U(:,1));
