function Gamma = preco(Uc,Up,gamma,dt,h)
%
%  Gamma = preco(Uc,Up,gamma,dt,h)
%

[N,ndof] = size(Uc);
g1 = gamma-1;

delta = 1;
Meps  = 1e-6;
xi    = 1;

c = sqrt(gamma*Up(:,3)./Up(:,1));
beta = c.^2; % Por ahora solo se considera el caso inviscido
M = abs(Up(:,2))./c;

CFLc = c*dt./h;

%% Mr = min([ones(size(M)) max([M Meps*ones(size(M))],[],2)],[],2);
Mr = min([ones(size(M)) max([sqrt(M.^2+xi./CFLc.^2) Meps*ones(size(M))],[],2)],[],2);

psi = g1./(beta.*Mr.^2);

XI     = (Uc(:,3)+Up(:,3))./(Uc(:,1).*beta.*Mr.^2)-delta;
THETA2 = -g1*(1+XI);
THETA1 = -0.5*Up(:,2).^2.*(1+THETA2)-c.^2/g1;

Gamma = zeros(N,ndof,ndof);
Gamma(:,1,1) = psi.*Up(:,2).^2/2;
Gamma(:,1,2) = -psi.*Up(:,2);
Gamma(:,1,3) = psi;
Gamma(:,2,1) = Up(:,2)/2.*(psi.*Up(:,2).^2-2);
Gamma(:,2,2) = 1-psi.*Up(:,2).^2;
Gamma(:,2,3) = psi.*Up(:,2);
Gamma(:,3,1) = THETA1;
Gamma(:,3,2) = THETA2.*Up(:,2);
Gamma(:,3,3) = 1-THETA2;
