%
%   Example 1 : Ej_00 : 
%           Diffusion with reaction c = 1 and no source
%           phi(x=0) = 0
%           phi(x=1) = 1

nen_ele  = 3 ; %Ne=20; Nx=Ne*(nen_ele-1)+1;

Nx=19;  
psi      = (0:Nx-1)'/(Nx-1);
Lx       = 1;
x        = psi*Lx;               % uniform grid 
%x        = (1+sin(-pi/2+psi*pi))/2;    % non uniform grid (refined at both ends)

%-------- coordinates (XNOD)
xnod= [x];

%-------- connectivities (ICONE)
ico = [ (1:Nx-1)' (2:Nx)' ];  icone = ico;

if nen_ele==2;
    type_geo_elem   = 'cartesian1d';
    type_x_interp   = 'linear';
    type_sol_interp = 'linear'; 
    icone = [ (1:Nx-1)' (2:Nx)' ];     
elseif nen_ele==3
    type_geo_elem   = 'cartesian1d';
    type_x_interp   = 'quadratic';
    type_sol_interp = 'quadratic';    
    ico  = [(1:2:Nx-2)' (2:2:Nx-1)' (3:2:Nx)'];  
    icone = ico;
elseif nen_ele==4
    type_x_interp   = 'cubic';
    type_sol_interp = 'cubic';        
    ico  = [(1:3:Nx-3)' (2:3:Nx-2)' (3:3:Nx-1)' (4:3:Nx)'];  
    icone = ico;    
end


%-------- fixations (FIXA)
[numnp,ndm]=size(xnod);
[numel,nen]=size(icone);
ndf = 1;
nodes_lef  = 1;
nodes_rig  = Nx;
fixa= zeros(numnp,ndf);
fixa(nodes_lef,1)=ones(length(nodes_lef),1);
fixa(nodes_rig,1)=ones(length(nodes_rig),1);

%-------- values of fixations (Dirichlet and Neumann)
forc= zeros(numnp,ndf);
forc(nodes_lef,1)=0*ones(length(nodes_lef),1);
forc(nodes_rig,1)=1*ones(length(nodes_rig),1);

%-------- Source term (by element) -----------------------------
source = zeros(numel,1);

%--------- Reactive term ( by element) -----------------------------
reac   = 1*ones(numel,1);

%--------- Velocity field -----------------------------
veloc  =  zeros(numnp,1);

%-------- Material properties 
kappa    =  1 ;
npg      =  2 ;
if strcmp(type_sol_interp,'cubic')
    npg      =  3 ;
end
upwind   =  0 ;
lumped   =  0 ;
nolineal =  0 ;
nolineal_function = 'ff_Ej_00';

%-------- Propiedades del material
ijob = 'set';
handle_prop_elem;

%-------- distributed fluxes
strg    = [];

%-------- Mixed boundary condition (Robin type) (TECO)
%                -k du/dn + h_film(u-u_0) = 0
% format for teco   
%               teco = [eles face val1 val2 ];
% with 
%
% eles    = element @ boundary;
% face    = face of the element @ boundary 
% val1    = h_film
% val2    = u_0
teco     = [];

%-------- periodic condition
lin_con = [];

%-------- Initial solution 
phi0 =  0;
bini = zeros(numnp,ndf);
for k=1:ndf,
    bini(:,k)   = forc(:,k);
    free        = find(fixa(:,k)==0);
    bini(free,k)= phi0(1,k)*ones(size(free));
end
