%
%   Example 2 : Ej_01 : 
%           Diffusion with source Q(x) = 1 for x < 1/2
%           phi(x=0) = 0
%           k*grad phi(x=1) = 0
%

Nx       = 21;  
Lx       = 1;
psi      = (0:Nx-1)'/(Nx-1);
x        = psi*Lx;

%-------- coordinates (XNOD)
xnod= [x];

%-------- connectivities (ICONE)
icone = [ (1:Nx-1)' (2:Nx)' ]; 

%-------- fixations (FIXA)
[numnp,ndm]=size(xnod);
[numel,nen]=size(icone);
ndf = 1;
nodes_lef  = 1;
nodes_rig  = Nx;
fixa= zeros(numnp,ndf);
fixa(nodes_lef,1)=ones(length(nodes_lef),1);
%fixa(nodes_rig,1)=ones(length(nodes_rig),1);

%-------- values of fixations (Dirichlet and Neumann)
forc= zeros(numnp,ndf);
forc(nodes_lef,1)=0*ones(length(nodes_lef),1);
%forc(nodes_rig,1)=1*ones(length(nodes_rig),1);

%-------- Source term (by element) -----------------------------
xc_ele = 0.5*(xnod(icone(:,2),1)+xnod(icone(:,1),1));
source = xc_ele<Lx/2;

%--------- Reactive term ( by element) -----------------------------
reac   = zeros(numel,1);

%--------- Velocity field -----------------------------
veloc  =  zeros(numnp,1);

%-------- Material properties 
kappa    =  1 ;
npg      =  2 ;
upwind   =  0 ;
lumped   =  0 ;
nolineal =  0 ;
nolineal_function = 'ff_Ej_00';

ijob = 'set';
handle_prop_elem;

%-------- distributed fluxes
strg    = [];

%-------- Mixed boundary condition (Robin type) (TECO)
%                -k du/dn + h_film(u-u_0) = 0
% format for teco   
%               teco = [eles face val1 val2 ];
% with 
%
% eles    = element @ boundary;
% face    = face of the element @ boundary 
% val1    = h_film
% val2    = u_0
teco     = [];

%-------- periodic condition
lin_con = [];

%-------- Initial solution 
phi0 =  0;
bini = zeros(numnp,ndf);
for k=1:ndf,
 bini(:,k)   = forc(:,k);
 free        = find(fixa(:,k)==0);
 bini(free,k)= phi0(1,k)*ones(size(free));
end

