upwind_type_2 = 'Balancing_diffusion';   % for non-consistent formulation
upwind_type_2 = 'supg';

T        = alpha*phi(:,1)+(1-alpha)*phiold;
T1       = phi(:,1);
Told     = phiold;

veloc    = data.PDE_param.veloc;
reac     = data.PDE_param.reac;
source   = data.PDE_param.source;

% Calculos del elemento propiamente dichos
%------------------------------------------------------------------

if nolineal ~=0,
    % Read archive which filename is storage at "data.props.nolineal_function" 
    % to update the parameters that depend on the solution
    filename = data.props.nolineal_function;
    if exist(filename)==2,
        eval([filename]);
    end
end

nen_x = nen;
if data.mesh.hierarchical_flag
    if strcmp(data.mesh.type_x_interp,'linear')==1
        nen_x = 2;
    end
end

% Localization of the variables (from nodal to element) 
%------------------------------------------------------------------
ceros = zeros(numel,nen);
Te = ceros;
T0e = ceros;
T1e = ceros;
velex = ceros;

for inod=1:nen,
    nodes = icone(:,inod);
    Te(:,inod) = T(nodes);
    T0e(:,inod) = Told(nodes);
    T1e(:,inod) = T1(nodes);
end

for inod=1:nen_x,
    nodes = icone(:,inod);    
    velex(:,inod) = veloc(nodes,1);    
end

% Loop over Gauss points
%------------------------------------------------------------------
for ipg=1:npg
    
    % Calculo de transformacion isoparametrica y funciones de forma
    %------------------------------------------------------------------

     if data.mesh.hierarchical_flag
        [X2S,S2X,Jaco]  = xy2st(xnod,icone(:,1:nen_x),psipg(ipg));        
        [dNdx,N]        = shape1d_hierarchical(X2S,psipg(ipg),data.mesh.type_sol_interp);         
    else
        [X2S,S2X,Jaco]  = xy2st(xnod,icone,psipg(ipg));        
        [dNdx,N]        = shape1d(X2S,psipg(ipg),data.mesh.type_sol_interp); 
    end
    
    % Interpolacion en punto de Gauss
    %------------------------------------------------------------------
    Tpg    = zeros(numel,1);
    T0pg   = zeros(numel,1);
    T1pg   = zeros(numel,1);    
    dTpg   = zeros(numel,1);
    velpg  = zeros(numel,1);
    xpg    = zeros(numel,1);
    
    for inod=1:nen,
        Tpg(:,1)   =     Tpg(:,1) +      N(inod).*    Te(:,inod);
        T0pg(:,1)  =    T0pg(:,1) +      N(inod).*   T0e(:,inod);
        T1pg(:,1)  =    T1pg(:,1) +      N(inod).*   T1e(:,inod);        
        dTpg(:,1)  =    dTpg(:,1) + dNdx(:,inod).*    Te(:,inod);
    end
    
    for inod=1:nen_x,
        velpg(:,1) =   velpg(:,1) +      N(inod).* velex(:,inod);        
        xpg        =         xpg  +      N(inod).* xnod(icone(:,inod),1);        
    end
    
    % Computation of the perturbation weight functions (Petrov-Galerkin)
    %------------------------------------------------------------------
    kappa_pg = kappa;
    if abs(kappa_pg)<1e-12, kappa_pg = 1e-12; end
    
    vel_supg = zeros(numel,1);
    for inod=1:nen_x,
        vel_supg(:,1)  =   vel_supg(:,1) +  N(inod).* velex(:,inod);
    end
    
    if upwind>0
        if strcmp(upwind_type,'Petrov_Galerkin') 
            mask_upwind_supg = 1; if strcmp(upwind_type_2,'Balancing_diffusion'), mask_upwind_supg=0; end
            if strcmp(data.mesh.type_sol_interp,'linear')
                hele     = 2*Jaco;
                tau      = upwind*supg1d(vel_supg,hele,kappa_pg);
                for inod=1:nen,
                    P1_pg(:,inod) = tau.*(vel_supg(:,1).*dNdx(:,inod));
                end
            elseif  strcmp(data.mesh.type_sol_interp,'quadratic')
                hele  = Jaco;  % for quadratic interpolation hele is the distance between nodes , not the element size
                Pe    = hele/2.*abs(vel_supg) ./ kappa_pg;
                fPe_mid = coth(Pe) - (1 ./ Pe);
                if 0
                    fPe_corner = ((coth(Pe)- (1 ./ Pe))-(cosh(Pe).^2).*(coth(2*Pe)- (1 ./ (2*Pe))))./(1- 0.5*(cosh(Pe).^2));
                elseif 0
                    fPe_corner = (2*Pe-1)+(-6*Pe+7).*exp(-2*Pe)+(-6*Pe-7).*exp(-4*Pe)+(2*Pe+1).*exp(-6*Pe);
                    fPe_corner = fPe_corner ./ ( (Pe+3)+(-7*Pe-3).*exp(-2*Pe)+(7*Pe-3).*exp(-4*Pe)-(Pe+3).*exp(-6*Pe) );
                elseif 0
                    Pe = min([Pe',100*ones(1,numel)])';
                    num =    (4*Pe.*(exp(Pe)-exp(-Pe))-Pe.*(exp(2*Pe)-exp(-2*Pe)) ...
                        - 8*(exp(-Pe)+exp(Pe))+14+ (exp(2*Pe)+exp(-2*Pe)));
                    den =     (12*(exp(Pe)-exp(-Pe))-6*(exp(2*Pe)-exp(-2*Pe)) ...
                        + 8*Pe.*(exp(-Pe)+exp(Pe))-14*Pe ...
                        -Pe.*(exp(2*Pe)+exp(-2*Pe)));
                    fPe_corner = 2*num ./ den;
                elseif 0
                    Pe = min([Pe',100*ones(1,numel)])';
                    fPe_corner = -2*((-4*exp(-Pe)-exp(2*Pe)+exp(-2*Pe)+4*exp(Pe)).*Pe-8*exp(-Pe)+14-8*exp(Pe)+exp(2*Pe)+exp(-2*Pe)) ...
                        ./ ((-8*exp(-Pe)+14-8*exp(Pe)+exp(2*Pe)+exp(-2*Pe)).*Pe-12*exp(Pe)+12*exp(-Pe)+6*exp(2*Pe)-6*exp(-2*Pe));
                elseif 0                
                    Pe = min([Pe',100*ones(1,numel)])';                    
                    fPe_mid = -1/2*(Pe.*exp(-2*Pe)+2*exp(-2*Pe)-4-Pe.*exp(2*Pe)+2*exp(2*Pe)) ./ Pe ./ (exp(-2*Pe)-2+exp(2*Pe));
                    
                    fPe_corner = -(-Pe.*exp(4*Pe)-4*Pe.*exp(-2*Pe)+4*Pe.*exp(2*Pe)+Pe.*exp(-4*Pe)-8*exp(-2*Pe)-8*exp(2*Pe)+exp(4*Pe)+14+ ...
                        exp(-4*Pe)) ./ ...
                                  (-8*Pe.*exp(2*Pe)-8*Pe.*exp(-2*Pe)+Pe.*exp(4*Pe)+14*Pe-12*exp(2*Pe)+12*exp(-2*Pe)+Pe.*exp(-4*Pe)+ ...
                                  6*exp(4*Pe)-6*exp(-4*Pe));
                else
                    Pe = min([Pe',100*ones(1,numel)])';      
%                    fPe_mid = -1/2*(Pe.*exp(-2*Pe)+2*exp(-2*Pe)-4-Pe.*exp(2*Pe)+2*exp(2*Pe)) ./ Pe ./ (exp(-2*Pe)-2+exp(2*Pe));
                    
%                    fPe_mid = 1/2*(-2*exp(-2*Pe)-Pe.*exp(-2*Pe)+Pe.*exp(2*Pe)-2*exp(2*Pe)+4) ./Pe ./ (exp(-2*Pe)-2+exp(2*Pe));
                    
                    fPe_mid = -1/2*(-Pe.*exp(-2*Pe)-2*exp(-2*Pe)+4+Pe.*exp(2*Pe)-2*exp(2*Pe)) ./ Pe ./ (-exp(-2*Pe)+2-exp(2*Pe))
 
                    fPe_corner = ...
                     (4*Pe.*exp(-2*Pe)-4*Pe.*exp(2*Pe)-Pe.*exp(-4*Pe)+Pe.*exp(4*Pe)+8*exp(-2*Pe)+8*exp(2*Pe)-exp(4*Pe)-exp(-4*Pe)-14) ./  ...
                         Pe ./ (-8*exp(-2*Pe)-8*exp(2*Pe)+exp(4*Pe)+14+exp(-4*Pe));
 
 
                end
                tau_mid = hele ./ (2*abs(vel_supg)).*fPe_mid;
                tau_corner = hele ./ (2*abs(vel_supg)).*fPe_corner;
                for inod=[1,3],
                    P1_pg(:,inod) = tau_corner.*(vel_supg(:,1).*dNdx(:,inod));
                end
                inod = 2;
                P1_pg(:,inod) = tau_mid.*(vel_supg(:,1).*dNdx(:,inod));

            else
                error(' interpolation not supported by upwind')
            end
        elseif strcmp(upwind_type,'Bubble_function')
            if strcmp(data.mesh.type_sol_interp,'linear')
                hele     = 2*Jaco;
                tau      = supg1d(vel_supg,hele,kappa_pg);
                for inod=1:nen,
                    P1_pg(:,inod) = tau.*(vel_supg(:,1).*dNdx(:,inod));
                    P1_pg(:,inod) = P1_pg(:,inod).*(3/2*(1-psipg(ipg).^2));                    
                end                
            else
                error(' bubble weighting function only supported for linear approximation yet ')
            end
        else
            error(' weighting function not supported by upwind')
        end
    else
        mask_upwind_supg=0;
        P1_pg = zeros(numel,nen);
    end

    if exist(ffun_source,'file')==0;
        source_pg = source;
    else
        eval(['source_pg = ' ffun_source '(xpg);']);
    end

    xsj =  wpg(ipg) .* Jaco;

    % Computation of tangent matrix and residue 
    %--------------------------------------------------------------------
    for inod=1:nen,
        
        if (jobinfo(1)==1)|(jobinfo(3)==0),
            for jnod=1:nen,                
                if lumped,
                    if inod==jnod, ter1 = (N(inod))/dt   ;else ter1=0; end
                else
                    ter1 = (N(inod)+P1_pg(:,inod))*N(jnod)/dt  ;
                end
                ter2 = (N(inod)+P1_pg(:,inod)).*velpg(:,1).*dNdx(:,jnod);
                ter3 = dNdx(:,inod).*dNdx(:,jnod).* kappa_pg  ;
                ter4 = (N(inod)+mask_upwind_supg*P1_pg(:,inod))*N(jnod).*reac ;
                Kele(:,inod,1,jnod,1) = Kele(:,inod,1,jnod,1) + (ter1+alpha*(ter2+ter3+ter4)).* xsj;	                    
            end  
            
        end % 
        
        if (jobinfo(1)==0)&(jobinfo(3)==1),
            % explicit case
            ter1 = (N(inod))/dt ;
            Kele(:,inod,1,inod) = Kele(:,inod,1,inod) + ter1 .* xsj;
        end 

        % Residue computation
        if lumped | ((jobinfo(1)==0)&(jobinfo(3)==1)),
            ter1 = (N(inod)).*(T1e(:,inod)-T0e(:,inod))/dt ;
        else
            ter1 = (N(inod)+P1_pg(:,inod)).*(T1pg-T0pg)/dt ;
        end
        ter2 = (N(inod)+P1_pg(:,inod)).*velpg(:,1).*dTpg(:,1) ;    
        ter3 = (dNdx(:,inod).*dTpg(:,1)).*kappa_pg ;
        ter4 = (N(inod)+mask_upwind_supg*P1_pg(:,inod)).*reac.*Tpg ;
        ter5 = -(N(inod)+mask_upwind_supg*P1_pg(:,inod)).*source_pg ;
        Rele(:,inod,1) = Rele(:,inod,1) - (ter1+ter2+ter3+ter4+ter5) .* xsj ;	            							 
    end % inod
    
end % ipg
