syms x psi a nu h tau_m tau_c

% shape functions in natural coordinates
N(1)   =   -x*(1-x)/2;
N(2)   =   (1-x)*(1+x);
N(3)   =   x*(1+x)/2;

N = subs(N,x,psi)

% advection and diffusion Galerkin terms
for kr=1:3,
    for kc=1:3 
        Ra(kr,kc) = int(N(kr)*a*diff(N(kc),psi),'psi',-1,1);
        Rd(kr,kc) = int(diff(N(kr),psi)*nu*diff(N(kc),psi)*2/h,'psi',-1,1);        
    end
end

% numerical diffusion
for kr=1:3,
    if kr == 2, tau = tau_m; else tau=tau_c; end
    P = diff(N(kr),psi)*2/h*a*tau;    
    for kc=1:3 
        Rd_num(kr,kc) = int(P*(a*diff(N(kc),psi)*2/h-nu*diff(diff(N(kc),psi),psi)*(2/h)^2)*h/2,'psi',-1,1);
    end
end

Rag = Ra;
Rdg = Rd;
Rd_num_g = Rd_num;
Rag(5,5) = 0;
Rdg(5,5) = 0;
Rd_num_g(5,5) = 0;
Rag(3:5,3:5) = Rag(3:5,3:5)+Ra;
Rdg(3:5,3:5) = Rdg(3:5,3:5)+Rd;
Rd_num_g(3:5,3:5) = Rd_num_g(3:5,3:5)+Rd_num;

Rg = Rag+Rdg+Rd_num_g;

R_c = Rg(3,:)
R_m = Rg(2,1:3)
