syms x xj psi a h Pe tau_m tau_c

% shape functions in natural coordinates
N(1)   =   -x*(1-x)/2;
N(2)   =   (1-x)*(1+x);
N(3)   =   x*(1+x)/2;

N = subs(N,x,psi)

% advection and diffusion Galerkin terms
for kr=1:3,
    for kc=1:3
        Ra(kr,kc) = int(N(kr)*a*diff(N(kc),psi),'psi',-1,1);
        Rd(kr,kc) = int(a/Pe*diff(N(kr),psi)*diff(N(kc),psi),'psi',-1,1);
    end
end

% numerical diffusion
for kr=1:3,
    if kr == 2, tau = tau_m; else tau=tau_c; end
    P = 2/h*diff(N(kr),psi)*a*a*tau / Pe;
    for kc=1:3
        Rd_num(kr,kc) = int(P*(Pe*diff(N(kc),psi)-diff(diff(N(kc),psi),psi)),'psi',-1,1);
    end
end

Rag = Ra;
Rdg = Rd;
Rd_num_g = Rd_num;
Rag(5,5) = 0;
Rdg(5,5) = 0;
Rd_num_g(5,5) = 0;
Rag(3:5,3:5) = Rag(3:5,3:5)+Ra;
Rdg(3:5,3:5) = Rdg(3:5,3:5)+Rd;
Rd_num_g(3:5,3:5) = Rd_num_g(3:5,3:5)+Rd_num;

Rg = Rag+Rdg+Rd_num_g;

R_c = Rg(3,:)
R_m = Rg(2,1:3)

ga = 2/h*Pe;

if 0
    up  = 1/a*( (xj+h) - (1-exp(ga*(xj+h)))/(1-exp(ga)));
    um  = 1/a*( (xj-h) - (1-exp(ga*(xj-h)))/(1-exp(ga)));
    up2 = 1/a*( (xj+2*h) - (1-exp(ga*(xj+2*h)))/(1-exp(ga)));
    um2 = 1/a*( (xj-2*h) - (1-exp(ga*(xj-2*h)))/(1-exp(ga)));
    up0 = 1/a*( (xj) - (1-exp(ga*(xj)))/(1-exp(ga)));
else
    up  =  1/a*(1-exp(ga*(xj+h)))/(1-exp(ga));
    um  =  1/a*(1-exp(ga*(xj-h)))/(1-exp(ga));
    up2 =  1/a*(1-exp(ga*(xj+2*h)))/(1-exp(ga));
    um2 =  1/a*(1-exp(ga*(xj-2*h)))/(1-exp(ga));
    up0 =  1/a*(1-exp(ga*(xj)))/(1-exp(ga));
end

vaux = simple(R_m * transpose([um up0 up]));
%pretty(vaux)

disp(' ****************  tau_m = ***********************')
tau_m2 = simple(solve(vaux,tau_m));
pretty(tau_m2)
