syms x xj psi a h Pe tau_m tau_c

nen = 3;

if nen==3
    % quadratic shape functions in natural coordinates
    N(1)   =   -x*(1-x)/2;
    N(2)   =   (1-x)*(1+x);
    N(3)   =   x*(1+x)/2;
else
    % linear shape functions in natural coordinates
    N(1)   =   (1-x)/2;
    N(2)   =   (1+x)/2;
end

N = subs(N,x,psi)

% advection and diffusion Galerkin terms
for kr=1:nen,
    for kc=1:nen
        Ra(kr,kc) = int(N(kr)*a*diff(N(kc),psi),'psi',-1,1);
        Rd(kr,kc) = int(a/Pe*diff(N(kr),psi)*diff(N(kc),psi),'psi',-1,1);
    end
end

% numerical diffusion
for kr=1:nen,
    if nen==3, if kr == 2, tau = tau_m; else tau=tau_c; end ; else tau=tau_m; end
    P = 2/h*diff(N(kr),psi)*a*a*tau / Pe;
    for kc=1:nen
        Rd_num(kr,kc) = int(P*(Pe*diff(N(kc),psi)-0*diff(diff(N(kc),psi),psi)),'psi',-1,1);
    end
end

Rag = Ra;
Rdg = Rd;
Rd_num_g = Rd_num;
Np = 2*(nen-1)+1;
Rag(Np,Np) = 0;
Rdg(Np,Np) = 0;
Rd_num_g(Np,Np) = 0;
indx = (nen-1)+(1:nen);
Rag(indx,indx) = Rag(indx,indx)+Ra;
Rdg(indx,indx) = Rdg(indx,indx)+Rd;
Rd_num_g(indx,indx) = Rd_num_g(indx,indx)+Rd_num;

Rg = Rag+Rdg+Rd_num_g;

if nen==3
    R_c = Rg(3,:);
    R_m = Rg(2,1:3);
else
    R_m = Rg(2,:);
end

ga = 2/h*Pe;

if 0
    up  = 1/a*( (xj+h) - (1-exp(ga*(xj+h)))/(1-exp(ga)));
    um  = 1/a*( (xj-h) - (1-exp(ga*(xj-h)))/(1-exp(ga)));
    up2 = 1/a*( (xj+2*h) - (1-exp(ga*(xj+2*h)))/(1-exp(ga)));
    um2 = 1/a*( (xj-2*h) - (1-exp(ga*(xj-2*h)))/(1-exp(ga)));
    up0 = 1/a*( (xj) - (1-exp(ga*(xj)))/(1-exp(ga)));
else
    up  =  1/a*(1-exp(ga*(xj+h)))/(1-exp(ga));
    um  =  1/a*(1-exp(ga*(xj-h)))/(1-exp(ga));
    up2 =  1/a*(1-exp(ga*(xj+2*h)))/(1-exp(ga));
    um2 =  1/a*(1-exp(ga*(xj-2*h)))/(1-exp(ga));
    up0 =  1/a*(1-exp(ga*(xj)))/(1-exp(ga));
end

vaux = simple(R_m * transpose([um up0 up]));
disp(' ****************  tau_m = ***********************')
tau_m2 = simple(solve(vaux,tau_m));
tau_m2 = subs(tau_m2,xj,0);
pretty(tau_m2)
ezplot(tau_m2*a*2/h,[-20,20])

vaux2 = simple(R_c * transpose([um2 um up0 up up2]));
disp(' ****************  tau_c = ***********************')
tau_c2 = simple(solve(vaux2,tau_c));
tau_c2 = subs(tau_c2,xj,0);
pretty(tau_c2)
ezplot(tau_c2*a*2/h,[-20,20])