%----------------------------------------------------------------------
%
%     example selector 
%
%     also define the general parameters
%
%----------------------------------------------------------------------

%caso     = 2;

type_geo_elem   = 'cartesian1d';
type_x_interp   = 'linear';
type_sol_interp = 'linear';    
hierarchical_flag = 0;

if caso==0,
    %                (FEM-interpolation with different interpolation order)
    Ej_00       %   Example # 1   du^2/dx2 - c*phi = 0 
elseif caso==1,
    Ej_01        %  Example # 2   du^2/dx2 + Q = 0 (with Q(x)=1 for x<Lx/2)
elseif caso==2,
    Ej_02        %  Example # 3   du^2/dx2 + Q = 0 (with Q(x)=-12*x^2)
elseif caso==3,
    Ej_03        %  Example # 4   du^2/dx2 - c*phi = 0  
elseif caso==4,
    Ej_04        %  Example # 5   du^2/dx2 + Q = 0 (with Q(x)=-12*x^2) using hierarchical basis  
elseif caso==5,
    %
    %Ej_05_a        %  Example # 6   du/dx = 0 , u(x=0)=0   
    %                                (with and without upwind , is the same , solution OK)
    %Ej_05_b        %  Example # 6    du/dx = 0 , u(x=0)=0 & u(x=Lx)= 1      
    %                                (with and without upwind is NOT the same , solution is bad without upwind)    
    %Ej_05_c        %  Example # 6   du/dx = Q , u(x=0)=0  (Q=1 , x<=Lx/2)
    %                                with  and without upwind , solution is
    %                                OK because the normal derivative at
    %                                outlet is null
    Ej_05_d        %  Example # 6   du/dx = Q , u(x=0)=0 % u(x=Lx)=0 (Q=1)
    %                                with upwind is OK, without upwind is
    %                                bad, removing u(x=Lx)=0 being free is
    %                                OK
elseif caso==6,
    %
    %Ej_06_a        %  Example # 7   -kappa*d2u/dx2 + a*du/dx = Q , u(x=0)=0 & u(x=Lx)=1 & Q=0
    %                               for different Peclets with and without
    %                               upwind
    %Ej_06_b        %  Example # 7    -kappa*d2u/dx2 + a*du/dx = Q ,u(x=0)=0& u(x=Lx)=1 &
    %                                Q=0.1
    %                               for different Peclets with and without
    %                               upwind 
    Ej_06_c        %  Example # 7    -kappa*d2u/dx2 + a*du/dx = Q ,u(x=0)=0& u(x=Lx)=0 &
    %                                Q=1
    %                               for different Peclets with and without
    %                               upwind     
    %Ej_06_d        %  Example # 7    -kappa*d2u/dx2 + a*du/dx = Q ,u(x=0)=0& u(x=Lx)=0 &
    %                                Q=5*exp(-100*(x-1/8)^2)-5*exp(-100*(x-1/4)^2)
    %                               for different Peclets with and without
    %                               upwind     
elseif caso==7,
    %
    Ej_07_a        %  Example # 8   du/dt - kappa*d2u/dx2 + a*du/dx = Q , u(x=0)=1 & Q=0
    %                               for u(t=0)=0 and for different Peclets with and without
    %                               upwind , implicit and explicit for different Courant   
else
    error(' MALA ELECCION DEL CASO A TRATAR')
end

data.mesh.xnod = xnod;
data.mesh.icone = icone;
data.mesh.type_geo_elem = type_geo_elem;
data.mesh.type_x_interp = type_x_interp;
data.mesh.type_sol_interp = type_sol_interp;
data.mesh.hierarchical_flag = hierarchical_flag;

data.bc.fixa = fixa;
data.bc.forc = forc;
if exist('strg')==0, strg=[]; end
data.bc.strg = strg;
if exist('teco')==0, teco=[]; end
data.bc.teco = teco;
if exist('lin_con')==0, lin_con=[]; end
data.bc.lin_con = lin_con;
if exist('ther_contact')==0, ther_contact=[]; end
data.bc.ther_contact = ther_contact;

data.props = prop;
data.props.ndm = 1;

data.PDE_param.veloc = veloc;
data.PDE_param.reac = reac;
data.PDE_param.source = source;

states.bini = bini;

limit    =   1e-06;
dt          = 1e+15 ;

%   Type_solver = 0 ---> direct method 
%               = 1 ---> Line search
%               = 2 ---> Explicit - Forward Euler
%               = 3 ---> GMRES  

type_solver = 0;
relax       = 1;     % relaxation parameter
nu_max      = 3;	 % maximum number of iterations each time step 
alfa_min    = 0.01;  % parameter for linesearch
alpha       = 1;     % trapezoidal time integration (1/2 Cranck-Nicholson)
ntime       = 2;    % number of time steps 
nstep       = 1;     % append the solution each nstep time steps in bfh_u array
scaling     = 0;     % scaling equations at solver for better conditioning of the system
nplot       = 1;     % plot each "nplot" time steps
nsave       = 1;     % save in memory the whole memory each nsave time steps

if caso==7
    Courant = 1;
    dt = 0.05*Courant;
    ntime = 100;
    nu_max= 2;
    nstep = 1;
    type_solver = 0;  
    alpha = 0.5;
end

if caso==6
    Courant = 0.8;
    dt      = min(abs(diff(xnod)))/max(abs(veloc))*Courant;
    ntime   = 100;
    nu_max  = 1;
    nstep   = 1;
    type_solver = 2;  
    alpha   = 1;
end

dt=1e15;
type_solver = 0;
ntime = 2;
nu_max = 2;

data.props.limit = limit;
data.props.dt = dt;
data.props.alpha = alpha;
data.props.type_solver = type_solver;
data.props.relax       = relax; 
data.props.nu_max      = nu_max;
data.props.ntime       = ntime;
data.props.nstep       = nstep;
data.props.nsave       = nsave;
data.props.scaling     = scaling;
data.props.alfa_min    = alfa_min;
