%function [data] = read_data()
%----------------------------------------------------------------------
%
%     example selector 
%
%     also define the general parameters
%
%----------------------------------------------------------------------

caso     = 2;

type_geo_elem   = 'cartesian1d';
type_x_interp   = 'linear';
type_sol_interp = 'linear';    

if caso==0,
    %                (FEM-interpolation with different interpolation order)
    Ej_00       %   Example # 1   du^2/dx2 - u = 0 
elseif caso==1,
    Ej_01        %  Ejemplo # 2   du^2/dx2 + Q = 0 (with Q(x)=1 for x<Lx/2)
elseif caso==2,
    Ej_02        %  Ejemplo # 3   du^2/dx2 + Q = 0 (with Q(x)=-12*x^2)
else
    error(' MALA ELECCION DEL CASO A TRATAR')
end

data.mesh.xnod = xnod;
data.mesh.icone = icone;
data.mesh.type_geo_elem = type_geo_elem;
data.mesh.type_x_interp = type_x_interp;
data.mesh.type_sol_interp = type_sol_interp;

data.bc.fixa = fixa;
data.bc.forc = forc;
if exist('strg')==0, strg=[]; end
data.bc.strg = strg;
if exist('teco')==0, teco=[]; end
data.bc.teco = teco;
if exist('lin_con')==0, lin_con=[]; end
data.bc.lin_con = lin_con;
if exist('ther_contact')==0, ther_contact=[]; end
data.bc.ther_contact = ther_contact;

data.props = prop;
data.props.ndm = 1;

data.PDE_param.veloc = veloc;
data.PDE_param.reac = reac;
data.PDE_param.source = source;

states.bini = bini;

limit    =   1e-06;
dt          = 1e+15 ;

%   Type_solver = 0 ---> metodo directo con un parametro de
%                        parametro de relajacion "relax"
%                        grado de implicitud (1/2 Cranck Nicholson) "alpha" (use >0)
%               = 1 ---> Line search
%               = 2 ---> Explicito - Forward Euler
%               = 3 ---> GMRES  

type_solver = 0;
relax       = 1;     % parametro de relajacion fijo para type_solver=0
nu_max      = 2;	   % numero maximo de iteraciones por paso de tiempo
alfa_min    = 0.01;  % para linesearch
alpha       = 1;     % grado de implicitud (1/2 Cranck-Nicholson)  
ntime       = 2;     % pasos de tiempo
nstep       = 1;     % guarda solucion cada nstep pasos de tiempo
nsave       = 5;     % Salva la memoria de c\'alculo cada nsave pasos de tiempo
scaling     = 1;     % scaling equations at solver for better conditioning of the system

if caso<2,
    type_solver = 0;
    relax       = 1;  % parametro de relajacion fijo para type_solver=0
    nu_max      = 5;
    ntime       = 2;
    nstep       = 10; % no interesa guardar la solucion en el tiempo
elseif caso==2,
    dt          = 0.5 ;
    type_solver = 0;
    relax       = 1;  % parametro de relajacion fijo para type_solver=0
    nu_max      = 2;
    ntime       = 30;
    nstep       = 3;
elseif caso==3,
elseif caso==4,
    dt          = 0.02/12.8 ;
    type_solver = 0;
    relax       = 1;  % parametro de relajacion fijo para type_solver=0
    nu_max      = 2;
    ntime       = 12.8*10;
    nstep       = 10;
elseif caso==5,
    dt          = 0.1 ;
    type_solver = 0;
    relax       = 0.5;  % parametro de relajacion fijo para type_solver=0
    nu_max      = 50;
    ntime       = 30;
    nstep       = 5;
elseif caso==51,
    dt          = 0.01 ;
    type_solver = 2;
    relax       = 0.5;  % parametro de relajacion fijo para type_solver=0
    nu_max      = 1;
    ntime       = 300;
    nstep       = 10;
    nsave       = 100;
elseif caso==6,
    dt          = 0.01 ;
    type_solver = 2;
    relax       = 0.5;  % parametro de relajacion fijo para type_solver=0
    nu_max      = 1;
    ntime       = 200;
    nstep       = 5;
    nsave       = 100;
    limit       = 1e-04;
elseif caso==7,
    dt          = 0.01 ;
    type_solver = 2;
    type_solver = 3;
    relax       = 0.5;  % parametro de relajacion fijo para type_solver=0
    nu_max      = 1;
    ntime       = 1000;
    nstep       = 10;
    nsave       = 100;
    limit       = 1e-04;
elseif caso==8,
    dt          = 0.01 ;
    type_solver = 0;
    relax       = 1;  % parametro de relajacion fijo para type_solver=0
    nu_max      = 5;
    ntime       = 10;
    nstep       = 5;
    nsave       = 100;
    limit       = 1e-04;   
end

data.props.limit = limit;
data.props.dt = dt;
data.props.alpha = alpha;
data.props.type_solver = type_solver;
data.props.relax       = relax; 
data.props.nu_max      = nu_max;
data.props.ntime       = ntime;
data.props.nstep       = nstep;
data.props.nsave       = nsave;
data.props.scaling     = scaling;
data.props.alfa_min    = alfa_min;
