%----------------------------------------------------------------------
%
%     example selector 
%
%     also define the general parameters
%
%----------------------------------------------------------------------

%caso     = 11 ;

type_geo_elem   = 'cartesian2d';
type_x_interp   = 'linear';
type_sol_interp = 'linear';    
hierarchical_flag = 0;

if caso==1,
    Ej2d_01      % heat equation with uniform source
elseif caso==2,
    Ej2d_02      % heat equation with a source located at the center of the domain
elseif caso==3,
    Ej2d_03      % heat equation with no source and linear reactive term
elseif caso==4,
    Ej2d_04      % higher order     
elseif caso==5,
    Ej2d_05      % mixed BC (teco)
    % Malla_1       % para generar una malla a partir de un laplaciano  
elseif caso==6,
    Ej2d_06      % mixed BC (teco) & periodic boundary condition   
    %Malla_2       % malla cuasi 1D  
    % difu1d      % difusion no estacionaria en malla cuasi 1D 
elseif caso==7,
    % ejemplo axisimetrico 
    Ej2d_axi      
elseif caso==8,
    % ejemplo uso de condicion convectiva TECO
    Ej2d_teco        
elseif caso==9,
    % ejemplo uso de condicion periodica
    Ej2d_peri
elseif caso==10,
    % ejemplo corona circular problema termico
    Ej_circulo    
elseif caso==11,
    Ej2d_07;
else
    error(' MALA ELECCION DEL CASO A TRATAR')
end

data.mesh.xnod = xnod;
data.mesh.icone = icone;
data.mesh.type_geo_elem = type_geo_elem;
data.mesh.type_x_interp = type_x_interp;
data.mesh.type_sol_interp = type_sol_interp;
data.mesh.hierarchical_flag = hierarchical_flag;

data.bc.fixa = fixa;
data.bc.forc = forc;
if exist('strg')==0, strg=[]; end
data.bc.strg = strg;
if exist('teco')==0, teco=[]; end
data.bc.teco = teco;
if exist('lin_con')==0, lin_con=[]; end
data.bc.lin_con = lin_con;
if exist('ther_contact')==0, ther_contact=[]; end
data.bc.ther_contact = ther_contact;

data.props = prop;
data.props.ndm = 1;

data.PDE_param.veloc = veloc;
data.PDE_param.reac = reac;
data.PDE_param.source = source;

states.bini = bini;
%states.phi  = bini;

data.props.limit       = limit;
data.props.dt          = dt;
data.props.alpha       = alpha;
data.props.type_solver = type_solver;
data.props.relax       = relax; 
data.props.nu_max      = nu_max;
data.props.ntime       = ntime;
data.props.nstep       = nstep;
data.props.nsave       = nsave;
data.props.scaling     = scaling;
data.props.alfa_min    = alfa_min;
