%----------------------------------------------------------------------
%
%     example selector 
%
%     also define the general parameters
%
%----------------------------------------------------------------------

caso     = 2 ; % trust element 
caso     = 3 ; % beam element 
caso     = 1 ; % elast 2D

type_geo_elem   = 'cartesian2d';
type_x_interp   = 'linear';
type_sol_interp = 'linear';    
hierarchical_flag = 0;

if caso==1,
    test_1      % elasticity in 2D 
elseif caso==2,
    if 0
        test_trust_1   % trust test from Oate book 
    elseif 1
        test_trust_2   % another trust test from Oate book 
    end    
elseif caso==3,
    % test_beam_1;  % simply supported beam with punctual load at its center 
    % test_beam_2;  % cantilever beam with punctual load at the free end. 
    % test_beam_3;
    % test_beam_4;  % reference:  R.H. Macneal and R.L.Harder, 
    % "A Proposed Standard Set of Problems To Test Finite
    % Element Accuracy", Finite Elements in Analysis and Design, 1, pp 3-20, 1985.
    % test_beam_5;  % PATRAN 322 Exercise Workbook
    test_beam_6;    % an structural test
else
    error(' MALA ELECCION DEL CASO A TRATAR')
end

data.mesh.xnod = xnod;
data.mesh.icone = icone;
data.mesh.type_geo_elem = type_geo_elem;
data.mesh.type_x_interp = type_x_interp;
data.mesh.type_sol_interp = type_sol_interp;
data.mesh.hierarchical_flag = hierarchical_flag;

data.bc.fixa = fixa;
data.bc.forc = forc;
if exist('strg')==0, strg=[]; end
data.bc.strg = strg;
if exist('teco')==0, teco=[]; end
data.bc.teco = teco;
if exist('lin_con')==0, lin_con=[]; end
data.bc.lin_con = lin_con;
if exist('ther_contact')==0, ther_contact=[]; end
data.bc.ther_contact = ther_contact;

data.props = prop;

data.PDE_param.source = source;

states.bini = bini;


limit    =   1e-06;

% Type_solver ------>  [ 0 ]  standard - direct method with relaxation (relax)
%                      [ 1 ]  line-search
%                      [ 2 ]  explicit
%                      [ 3 ]  GMRES
%                      [ 4 ]  QMR


type_solver = 0;
relax       = 1;     % relaxation parameter
nu_max      = 1;	 % maximum number of iterations each time step 
alfa_min    = 0.01;  % parameter for linesearch
alpha       = 1;     % trapezoidal time integration (1/2 Cranck-Nicholson)
ntime       = 2;    % number of time steps 
nstep       = 1;     % append the solution each nstep time steps in bfh_u array
scaling     = 0;     % scaling equations at solver for better conditioning of the system
nplot       = 1;     % plot each "nplot" time steps
nsave       = 5;     % save in memory the whole memory each nsave time steps
dt          = 1e+15;   

data.props.limit       = limit;
data.props.dt          = dt;
data.props.alpha       = alpha;
data.props.type_solver = type_solver;
data.props.relax       = relax; 
data.props.nu_max      = nu_max;
data.props.ntime       = ntime;
data.props.nstep       = nstep;
data.props.nsave       = nsave;
data.props.scaling     = scaling;
data.props.alfa_min    = alfa_min;
