%------------------------------------------------------------------
%       " Driver of F E M C O D E "
%------------------------------------------------------------------

if(exist('initia')==0),
    disp('Enter variable INITIA ')
    disp(' initia == 0 ---> if is a continuation of an older run  ')
    disp(' initia ~= 0 ---> if started from the beginning  ')
    initia = input(' Initia = ')
end

%------ Input data -------------------------------------------
if initia,
    bfh=[];          % Guarda la solucion
    hc_res=[];       % Guarda la historia de la convergencia en residuo
    hc_du=[];        % Guarda la historia de la convergencia en dphi
    bfh_nc = [];     % Guarda los pasos de tiempo en que no hubo convergencia
    bfh_u=[];        % Guarda la solucion cada nstep pasos de tiempo
    ttime = 0;
    level_ref =0;
    icone_prop = [];

    read_data;
    posdat;

    [rowe,cole] = gen_matrix_ij(icone,ndf);

    data.system.row = rowe;
    data.system.col = cole;
    clear rowe cole

end

phi   = states.phi;
states.phiold = phi;

%------ end input data --------------------------------------

% Loop temporal o pseudotemporal
%------------------------------------------------------------------

for itime=1:data.props.ntime,
    ttime = ttime+data.props.dt;

    phiold = phi;

    % Actualiza las condiciones de contorno si fueran funcion del tiempo
    % La funcionalidad se lee del archivo "bc_time"
    if exist('bc_time_flag')==1,
        if (bc_time_flag==1)&(exist('bc_time')~=2),
            disp('Debe tener en el directorio de trabajo un archivo de nombre bc_time.m ');
            error(' bc_time_flag==1 y bc_time file no existe ');
        end
        if bc_time_flag==1, bc_time; end
    end

    nu    = 0;
    iterflag = 1;
    [numnp,ndf] = size(phi);

    while iterflag

        nu= nu+1;

        phi_nu = phi;

        jobinfo = [1,1,0];  % default for implicit matrix and vector assembling
        if type_solver ==2, jobinfo=[0,1,1]; end  % for explicit resolution (mass matrix and residue)

        % assembling the residual (Rg) and the tangent matrix (Kg)
        [Kg,Rg] = assemble(data,states,jobinfo,'elast_2d');

        % Solving the linear system
        %------------------------------------------------------------------
        [phi,Rg]=solver(phi,Rg,Kg,fixa,data.props,1);

        if data.props.compute_stress,
            return
        end

        % Analisis de la convergencia
        %------------------------------------------------------------------
        Rg_r = Rg;
        iterflag = (norm(Rg_r)>limit) & (nu< nu_max); % & (norm(dphi)>limit);

        dphi = phi-phi_nu;

        disp(['time ' num2str(itime) ...
            ' Iter ' num2str(nu)  ' || R || -----> ' num2str(norm(Rg_r)) ...
            ' || Delta phi || -----> ' num2str(norm(dphi))  ])

        hc_res  = [hc_res ; norm(Rg_r)];
        hc_du   = [hc_du ; norm(dphi)];

        states.phi = phi;

    end  % end while

    % Salida grafica de resultados (provista por cada aplicacion)
    %------------------------------------------------------------------
    plot_fem

    if norm(Rg_r)>limit ,
        bfh_nc = [bfh_nc ; itime];
    end

    if exist('nsave')==0; nsave=ntime;end

    if exist('filesave')==0; filesave='tempo'; end

    if rem(itime,nsave)==0,
        eval(['save ' filesave ';']);
    end

    if rem(itime,nstep)==0,
        bfh_u = [bfh_u , phi];
    end

    states.phi = phi;
    states.phiold = phiold;

end % itime loop
