function [Kg,Rg] = elast_2d(xnod,icone,ifaceb,fixa,forc,lin_con,prop,prop_elem,icone_prop,...
    source,bou_strg,U,Uold,rowe,cole);
%------------------------------------------------------------------
%
%     [Kg,Rg] = elast_2d(xnod,icone,ifaceb,fixa,forc,lin_con,prop,prop_elem,icone_prop,...
%                        source,bou_strg,U,Uold,rowe,cole)
%
%       Caracteristicas del elemento:
%
%        #.- elasticidad 2D
%        #.- elemento cuadrangular y triangular
%        #.- plano y axisimetrico
%
%        ijob = 1 ---> matriz tangente y residuo
%        ijob = 0 ---> solo residuo
%
%------------------------------------------------------------------

ijob = 'get';
handle_prop_elem;

[numel,nen]   = size(icone);
if min(icone(:,nen))<=0,
    id_material = abs(icone(:,nen));
    nummat = max(id_material)-min(id_material)+1;
    icone = icone(:,1:nen-1);
else
    nummat = 1;
    id_material = ones(numel,1);
    
    if 0,
        [nr,nc]=size(prop);
        if nr==1, prop=prop'; end
        [nr,nc]=size(prop);   
        prop = prop(:,1);
    end
    
end

[numel,nen]   = size(icone);
[numnp,ndf]   = size(U);
[numnp,ndm]   = size(xnod);

[bas,ibas] = size(prop_elem);
if ibas<nummat, error(' prop_elem array should have nummat columns '); end

if ((ndm==1)|(beam_theory)),
    pgauss1d;
elseif ndm==2, 
    pgauss2d; 
elseif ndm==3,
    pgauss3d; 
end

Kele = zeros(numel,nen,ndf,nen,ndf);
Rele = zeros(numel,nen,ndf);

if nummat>1, error(' NUMMAT > 1 -> NOT YET AVAILABLE'); end
for k=1:nummat,  
    eles  = find(id_material==k);  
    if length(eles)>0,    
        if beam_theory
            if compute_stress
                npg = 1;
                pgauss1d;                
                flag_terms = [0,0,0,0];  % flag_term = [bending , shear , axial , torsion ]
                elast_2d_ele_beam;  
                my_fprintf('stress_PG.sal','%20.10e %20.10e %20.10e  \n',stress)
                return
            else
                flag_terms = [1,0,1,1];  % flag_term = [bending , shear , axial , torsion ]
                elast_2d_ele_beam;            
                npg = 1;
                pgauss1d;
                flag_terms = [0,1,0,0];  % flag_term = [bending , shear , axial , torsion ]
                elast_2d_ele_beam;                        
            end
        else
            elast_2d_ele;
        end
    end
end

% ------ Terminos de contorno
ceros = zeros(length(eles),ndf*nen);
Ue = ceros;   

for inod=1:nen,      
    nodes = icone(eles,inod);
    jnod = (inod-1)*ndf+(1:ndf);
    Ue(:,jnod) = U(nodes,:);
end

% Traction at boundaries
%------------------------------------------------------------------
if ~isempty(bou_strg),
    if beam_theory    
        error(' ***  ERROR IN BOU_STRG APPLIED TO BEAM THEORY ***')
    else
        [Kele,Rele] = bc_elast_2d(xnod,icone,Ue,bou_strg,Rele,Kele,prop);
    end
end

% rotate residual and matrix of the system from local to global frame
[Rele,Kele] = rotate_system(xnod,icone,Rele,Kele,nen,ndf);

% Gather contributions from eles to nodes
%------------------------------------------------------------------
[Rg,Kg] = gather_2(Rele,Kele,icone,nen,ndf,rowe,cole);
free = find(fixa==0);
Rg(free) = Rg(free) + forc(free);

% Linear restrictions
%------------------------------------------------------------------
if isempty(lin_con)==0,[Rg,Kg] = linear_constraint(Rg,Kg,lin_con,ndf);end

% disp('fem001');keyboard;pause