% 
%  handle_prop_elem
%

if strcmp(ijob,'get')
    
    % get_prop_elem
    
    %%%%%%%%%%%%%% PROPIEDADES DEL MATERIAL 
    
    rho        = prop.rho ;
    young      = prop.young ;
    poisson    = prop.poisson ;  
    npg        = prop.npg ;
    plane_stress = prop.plane_stress;
    gravity    = prop.gravity;
    beam_theory = prop.beam_theory;
    axisim     = prop.axisim ;
    g_dir      = prop.g_dir;
    compute_stress = prop.compute_stress;
    width      = prop.width;
    height     = prop.height;
    
    ttime      = prop.ttime;
    dt         = prop.dt;
    
    I_xx =  prop.icone_prop(:,1);
    I_yy =  prop.icone_prop(:,2);
    I_zz =  prop.icone_prop(:,3);
    I_x  =  prop.icone_prop(:,4);
    I_y  =  prop.icone_prop(:,5);
    Area =  prop.icone_prop(:,6);
    
    %%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
elseif strcmp(ijob,'set'),
    
    %  set_prop_elem
    
    prop.rho =  rho  ;
    prop.young =  young;
    prop.poisson =  poisson;
    prop.npg =  npg;
    prop.plane_stress =  plane_stress; 
    prop.gravity = gravity;
    prop.axisim = axisim;

    if ~exist('g_dir','var'),        
       g_dir = 2; 
    end    
    prop.g_dir = g_dir;
    
    if ~exist('compute_stress','var'),        
        compute_stress = 0;
    end
    prop.compute_stress= compute_stress;

    if ~exist('beam_theory','var'),        
       beam_theory = 1; 
    end    
    prop.beam_theory = beam_theory; 

    if ~exist('width','var'),        
       width = 0; 
    end    
    prop.width = width;

    if ~exist('height','var'),        
       height = 0; 
    end        
    prop.height = height;
    
    if exist('dt','var')>0,
        prop.dt = dt;      
    end
    
    if exist('ttime','var')>0,
        prop.ttime = ttime;      
    else
        ttime = 0;
        prop.ttime = ttime;
    end
    
    if ~exist('I_xx','var'),            
        I_xx = 0;
        I_yy = 0;
        I_zz = 0;
        I_x = 0;
        I_y = 0;
        Area = 0;        
    end
    
    prop.icone_prop(:,1) = I_xx;
    prop.icone_prop(:,2) = I_yy;
    prop.icone_prop(:,3) = I_zz;
    prop.icone_prop(:,4) = I_x;
    prop.icone_prop(:,5) = I_y;
    prop.icone_prop(:,6) = Area;
    
else
    error(' Bad ijob choice for HANDLE_PROP_ELEM')
end
