%----------------------------------------------------------------------
%
%          Fichero de datos
%
%----------------------------------------------------------------------

caso     = 1 ; % elast 2D
caso     = 2 ; % trust element (barra)
caso     = 3 ; % beam element (viga)

if caso==1,
    test_1      % test 1 elemento elastico 2D
elseif caso==2,
    if 0
        test_trust_1   % ejemplo del libro de Oate que sirve para ver en forma
        % cualitativa si el elemento de barra funciona bien 
    elseif 1
        test_trust_2   % ejemplo del libro de Oate que sirve para ver en forma
        % cualitativa si el elemento de barra funciona bien 
    else        
    end    
elseif caso==3,
    % test_beam_1;  % viga simplemente apoyada con carga puntual en el centro 
    % test_beam_2;  % viga en voladizo con carga puntual en un extremo
    % test_beam_3;
    % test_beam_4;  % referencia:  R.H. Macneal and R.L.Harder, 
                  % "A Proposed Standard Set of Problems To Test Finite
                  % Element Accuracy", Finite Elements in Analysis and Design, 1, pp 3-20, 1985.
    % test_beam_5;  % PATRAN 322 Exercise Workbook
    test_beam_6;  % test hecho por Juan Pablo con el Cosmos
else
    error(' MALA ELECCION DEL CASO A TRATAR')
end

limit    =   1e-06;

% Type_solver ------>  [ 0 ]  standard - directo con relajacion (relax)
%                      [ 1 ]  line-search
%                      [ 2 ]  explicito
%                      [ 3 ]  GMRES
%                      [ 4 ]  QMR

dt          = 0.0001 ;
type_solver = 0;
relax       = 1;     % parametro de relajacion fijo para type_solver=0
nu_max      = 1;	  % numero maximo de iteraciones por paso de tiempo
alfa_min    = 0.01;  % para linesearch
alpha       = 1;     % grado de implicitud (1/2 Cranck-Nicholson)
ntime       = 2;  % pasos de tiempo
nstep       = 1;     % guarda solucion cada nstep pasos de tiempo
scaling     = 0;     % scaling equations at solver for better conditioning of the system
nplot       = 1;     % plot cada "nplot" pasos de tiempo

if caso==1,
    type_solver = 0; scaling = 0;
    relax       = 1;  % parametro de relajacion fijo para type_solver=0
    nu_max      = 5;
    ntime       = 2;
    alpha       = 1;
    nstep       = 10; % no interesa guardar la solucion en el tiempo
    dt          = 1e+15;   
    nplot       = 1;
end

prop(12)  = limit    ;
prop(13)  = dt    ; % paso de tiempo
prop(14)  = alpha ; % grado de implicitud  

prop_solver = [type_solver,relax,nu_max,alfa_min,alpha,ntime,nstep,scaling];

