function [Rele,Kele] = rotate_system(xnod,icone,Rele,Kele,nen,ndf)
%
%            [Rele,Kele] = rotate_system(xnod,icone,Rele,Kele,nen,ndf)
%
% Transform element-wise residual and matrix from local to global system
%

numel = size(icone,1);
% local reference frame
ex = xnod(icone(:,2),:)-xnod(icone(:,1),:);
ex = ex./(sqrt(sum(ex'.^2))'*ones(1,3));

ey = pvec([1,0,0],ex);
eynorm = sqrt(sum(ey'.^2))';
nn = find(eynorm<1e-10);
if ~isempty(nn), 
    ey(nn,:) = pvec([0,1,0],ex(nn,:)); 
    eynorm = sqrt(sum(ey'.^2))';    
end
nn = find(eynorm<1e-10);
if ~isempty(nn), 
    ey(nn,:) = pvec([0,0,1],ex(nn,:)); 
    eynorm = sqrt(sum(ey'.^2))';    
end
nn = find(eynorm<1e-10);
if ~isempty(nn), error('***  it is impossible to orthogonalize the axial versor ***'); end

ez = pvec(ex,ey);
ez = ez./(sqrt(sum(ez'.^2))'*ones(1,3));

ey = pvec(ez,ex);
ey = ey./(sqrt(sum(ey'.^2))'*ones(1,3));

tmp = ex;
ex = ey;
ey = ez;
ez = tmp;

% transformation from global reference system to local reference system
RR(:,1:3,1) = ex;
RR(:,1:3,2) = ey;
RR(:,1:3,3) = ez;

RRx = RR;
RRx(:,4:6,4:6) = RR;
RRxT = row_transp(RRx);

for inod=1:nen
    Rele_GS(:,inod,1:ndf) = rowprod(RRx,reshape(Rele(:,inod,:),numel,ndf),ndf,ndf,1);
    for jnod=1:nen
        vaux = rowprod(RRx,reshape(Kele(:,inod,:,jnod,:),numel,ndf,ndf),ndf,ndf,ndf);
        Kele_GS(:,inod,1:ndf,jnod,1:ndf) = rowprod(vaux,RRxT,ndf,ndf,ndf);
    end
end

Rele = Rele_GS;
Kele = Kele_GS;


