function [xpg,phipg] = get_nodal_values_from_higher_order(data,states,nen_ele)

xnod = data.mesh.xnod;
icone = data.mesh.icone;
phi = states.phi;
numel = size(icone,1);

phi_p = phi;

Np = 10;

phipg = zeros(numel,Np+1);
xpg = zeros(numel,Np+1);

if nen_ele>2,
    for kk=0:Np
        n1 = icone(:,1);
        n2 = icone(:,nen_ele);
        psipg = -1+(kk/Np)*2;
        [X2S,S2X,Jaco] = xy2st(xnod,icone,psipg);
        [dNdx,N]       = shape1d(X2S,psipg,data.mesh.type_sol_interp);

        for inod=1:nen_ele,
            nodes = icone(:,inod);
            xpg(:,kk+1)   =     xpg(:,kk+1) +      N(inod).*   xnod(nodes,1);
            phipg(:,kk+1) =   phipg(:,kk+1) +      N(inod).*    phi(nodes,1);
        end

    end
else
    error(' *** Error in get_nodal_values_from_higher_order routine *** --> Check the order of the element ')
end

xpg=reshape(xpg,numel*(Np+1),1);
phipg=reshape(phipg,numel*(Np+1),1);
[xpg,ibas]=sort(xpg);
phipg=phipg(ibas);
tol = 1e-5;
dxpg = diff(xpg);
nn=find(dxpg<tol);
xpg(nn)=[];
phipg(nn)=[];
