function C=rowprod(A,B,m,n,p,A_flag,B_flag);
%
%          C=rowprod(A,B,m,n,p);
%

if nargin<7, B_flag=1; end
if nargin<6, A_flag=1; end

if (A_flag>0)&(B_flag>0),
    C=zeros(length(A(:,1)),m,p);    
    for i=1:m
        for j=1:p
            for k=1:n
                C(:,i,j)=C(:,i,j)+A(:,i,k).*B(:,k,j);
            end
        end
    end    
elseif (A_flag<0),
    C=zeros(length(B(:,1)),m,p);
    % A is a constant array (not depend on the nodal index, )
    for i=1:m
        for j=1:p
            for k=1:n
                C(:,i,j)=C(:,i,j)+A(i,k).*B(:,k,j);
            end
        end
    end    
elseif (B_flag<0),
    C=zeros(length(A(:,1)),m,p);    
    % B is a constant array (not depend on the nodal index, )
    for i=1:m
        for j=1:p
            for k=1:n
                C(:,i,j)=C(:,i,j)+A(:,i,k).*B(k,j);
            end
        end
    end    
else
    error(' ***** check the 6th and 7th argument in the calling to rowprod routine ***** ')
end
