function [X2S,S2X,Jaco] = xy2st1d(xnod,icone,psipg);
%-------------------------------------------------------------------
%          --- FEMCODE routine --- 
%
%     [X2S,S2X,Jaco] = xy2st1d(xnod,icone,psipg);
%
%  (1) Calculo del jacobiano y tensor metrico transformacion
%      al elemento master
%
%  solo para 1D , tiene en cuenta una curva en el espacio
%
%-------------------------------------------------------------------

[nnod,ndm]=size(xnod);
[nele,nen]=size(icone);

xs = v2m(xnod(icone,1),nele)';
if ndm>1, xs = [xs, v2m(xnod(icone,2),nele)'];end
if ndm==3, xs = [xs, v2m(xnod(icone,3),nele)'];end
      
if nen==2,

 dN1d1  = -0.5;
 dN2d1  = +0.5;
 
 x1     = xs(:,1);
 x2     = xs(:,2);
 dxdpsi = x1*dN1d1+x2*dN2d1;
 
 dydpsi = [];
 dzdpsi = [];
  
 if ndm>1
 y1     = xs(:,3);
 y2     = xs(:,4);
 dydpsi = y1*dN1d1+y2*dN2d1;
 end
 
 if ndm==3
 z1     = xs(:,5);
 z2     = xs(:,6);
 dzdpsi = z1*dN1d1+z2*dN2d1;
 end
 
 VER COMO HACERLO LUEGO
 
 Jaco   = dxdpsi;
 S2X    = [dxdpsi,dydpsi,dzdpsi];
 X2S    = 1 ./ S2X;

elseif nen==3,
% Elementos cuadraticos

 dN1d1  = -0.5*(1-2*psipg);
 dN2d1  = -2*psipg;
 dN3d1  = +0.5*(1+2*psipg);
 x1     = xs(1,:)';
 x2     = xs(2,:)';
 x3     = xs(3,:)';
 dxdpsi = x1*dN1d1+x2*dN2d1+x3*dN3d1;
 Jaco   = dxdpsi;
 S2X    = dxdpsi;
 X2S    = 1 ./ Jaco;

elseif nen==4,
% Elementos cubicos

dN1d1 =  -9/16*( ... 
  (psipg-1/3)*(psipg-1)+(psipg+1/3)*(psipg-1)+(psipg+1/3)*(psipg-1/3));
dN2d1 = +27/16*( ...
  (psipg-1/3)*(psipg-1) + (psipg+  1)*(psipg-1) + (psipg+  1)*(psipg-1/3));
dN3d1 = -27/16*( ... 
 (psipg+1/3)*(psipg-1) + (psipg+  1)*(psipg-1) + (psipg+  1)*(psipg+1/3));
dN4d1 =  +9/16*( ...
 (psipg+1/3)*(psipg-1/3)+(psipg+  1)*(psipg-1/3)+(psipg+  1)*(psipg+1/3));
 x1     = xs(1,:)';
 x2     = xs(2,:)';
 x3     = xs(3,:)';
 x4     = xs(4,:)';
 dxdpsi = x1*dN1d1+x2*dN2d1+x3*dN3d1+x4*dN4d1;
 Jaco   = dxdpsi;
 S2X    = dxdpsi;
 X2S    = 1 ./ Jaco;

else,
  error(' Mala eleccion de las funciones de interpolacion')
end


